### 实验九 矩阵键盘

#### 矩阵键盘的工作原理

当一个按键两端分别接一个IO口，一个IO口置高电平另一个置低电平，当按下按键时高电平IO口电平被拉低，另一端还是为低电平，这时检测IO口值就是两个低电平。      

把上述方法应用到矩阵键盘上，如果把4个行引脚接P2前4位IO口(P2.0~P2.3)，都置低电平，把4个列引脚接P2后4位IO口(P2.4~P2.7)，都置高电平，这时P2=0xf0, 如果按下第一列第一行按键，那么第一列的IO口电平变低，其他IO口电平不变，这时保存P2值，确定了列值。      

同样，用这种方法确定行值，就是在保存列值后把4个行引脚置高电平，4个列引脚置低电平，P2=0x0f(这时按键还处于按下的状态)，确定行值，最后把列值行值进行或运算得出一个保存了行值和列值的数(每个按键都有一个对应的数值)

![image-20221206103708505](E:\派哟项目\Hexbot项目\HEXBot_使用手册\ESP32使用手册\实验九 矩阵键盘\矩阵键盘.png)

#### 代码讲解

方法一 不使用库文件来编写

不使用库来书写矩阵键盘，可以使用行列扫描的办法来实现，即如下图代码。

![image-20221206103925055](E:\派哟项目\Hexbot项目\HEXBot_使用手册\ESP32使用手册\实验九 矩阵键盘\key—.png)

方法二 使用库文件来书写

编写矩阵键盘我们可以使用Keypad库来书写

这里涉及几个函数

**Keypad( makeKeymap(keys), pin_rows, pin_column, ROW_NUM, COLUMN_NUM );**

矩阵键盘的初始化设置，makeKeymap(keys)是预设引脚，括号内的key必须是一个二维数组，后面的依次是矩阵键盘的行列，以及行列的行列引脚数

**keypad.getKey();**

判断按键是否按下。

#### 程序源码

```
#include <Keypad.h>

#define ROW_NUM   3 // four rows

#define COLUMN_NUM  4 // three columns

char keys[ROW_NUM][COLUMN_NUM] = {

 {'1', '2', '3','*'},

 {'4', '5', '6','0'},

 {'7', '8', '9','#'}

};



byte pin_rows[ROW_NUM] = {23, 21, 19}; // GIOP18, GIOP5, GIOP17, GIOP16 connect to the row pins

byte pin_column[COLUMN_NUM] = {18,5, 2, 4};  // GIOP4, GIOP0, GIOP2 connect to the column pins

Keypad keypad = Keypad( makeKeymap(keys), pin_rows, pin_column, ROW_NUM, COLUMN_NUM );

void setup() {

 Serial.begin(9600);

}

void loop() {

 char key = keypad.getKey();

 if (key) {

  Serial.println(key);

 }

}
```

